@ These GAUSS procedures evaluate Markov transition matrix, evaluate
   likelihood function, and evaluate filter and smoothed probababilities @

/* ============================================================== */
proc matf(pm);  @This proc returns the (n x n) matrix F of Markov
                  transition probabilities for state vector @
local iz,iw,ib,na,nb,nc,fz,fm;
na = 1;nb = ns;nc = ns*ns;fm = pm;iz = 1;  do until iz > ps;     fz = fm;
     fm = zeros(nc,nc);     iw = 1;     do until iw > ns;
         fm[((iw-1)*nb+1):(iw*nb),((iw-1)*na+1):(iw*na)]
            = fz[1:nb,((iw-1)*na+1):iw*na];
     iw = iw+1;
     endo;
     ib = 2;
     do until ib > ns;
        fm[1:nc,((ib-1)*nb+1):ib*nb]  = fm[1:nc,1:nb];
     ib = ib+1;
     endo;
     na = na*ns;
     nb = nb*ns;
     nc = nc*ns;
  iz = iz+1;
  endo;
retp(fm);
endp;
/* ==================================================================== */


/* ================================================================= */
proc ofn(th);  @ this proc evaluates filter probs and likelihood @
   local ncount,mu,mui,phi1,sig,pm,eta,eta1,eta2,eta3,iz,fm,chsi,it,f,fit,fx,hw,
    detm,fj,ij,ap,const,pq,hk,ihk,n,x,qwd,phi2,hp5,hp6,phit1,phit2,const1,
lelo,le1,tia,const11,const2,eta11,eta22,lu,lux,luck,ta,lulu,lu2,lux2,lulu2
,lu3,lux3,lulu3,lead,ly,conti1,eta12,hpp;

@ Convert parameter vector to convenient form @
   mu = th[1:ns,1]~th[ns+1:2*ns,1];
   ncount = ns*2 + 1;  @ ncount is the number of params read @
      phi1 = 1 | -th[ncount:ncount+pphi-1];
   ncount = ncount + pphi;
      phi2 = 1 | -th[ncount:ncount+pphi-1];
   ncount = ncount + pphi;
   sig=zeros(2,2);
   sig[1,1] = th[ncount,1];
   sig[1,2] =th[ncount+1,1];
   sig[2,2] =th[ncount+2,1];
  sig = sig'* sig;
  ncount = ncount+3;
   pm = matpm(th[ncount:nth,1]);

  PHIT1=PHI1[1:PPHI,1];
  PHIT2=PHI2[1:PPHI+1,1];


@ Construct constant term to be subtracted for each observation @
 mui=zeros(ns,ns);
 mui[.,1] = mu[.,2];
 mui[.,2] = mu[.,1];
 const1 = phiT1 .*. mu[.,1]|zeros(2,1);
 conti1=PHI1[pphi+1:pphi*1+1,1].*.MUi[.,1];
 const1=const1|conti1;
 const2 = phiT2 .*. mu[.,2];

 hpp=hp[3:2+2*ps,.]|hp[3:2+2*pphi,.];
 const1 = const1'*hpp;

 const2 = const2'*hp[1:2+2*pphi,.];
 const =const1|const2;

@ Convert data to AR resids @
  eta11 = y[nk:capt,1];
  iz = 1;
    do until iz > pphi-1;
       eta11 = eta11 ~y[nk-iz:capt-iz,1];
    iz = iz+1;
    endo;
  eta12 = y[nk-1:capt-1,2];
  iz = 1;
    do until iz > pphi-1;
       eta12 = eta12 ~y[nk-iz-1:capt-iz-1,2];
    iz = iz+1;
    endo;
  eta1=eta11~eta12;
  eta1 = (eta1*phi1);

 eta2 = y[nk:capt,2];
 iz = 1;
 do until iz > pphi;
     eta2 = eta2~y[nk-iz:capt-iz,2];
   iz = iz+1;
   endo;
  eta22=eta2;
 eta22 = (eta22*phi2);
  eta3 = eta1 ~eta22;
@We have now ns^pphi+1 states of the nature, then we can define:@
 n = ns^(ps+1);
 eta = zeros (capt-nk+1,n);
 qwd=invPD(sig);
 iz = 1;
 n = ns^(ps+1);
 do until iz > n;
 x = 1;
 do until x >capt -nk+1;
 eta[x,iz] = (eta3[x,.] - const[.,iz]')*qwd*(eta3[x,.] - const[.,iz]')';

 x = x + 1;
 endo;
 iz = iz + 1;
 endo;

  detm = det(sig);
  eta = (1./sqrt(detm)).*exp(-eta/2);

@ Calculate ergodic probabilities @
     fm = matf(pm);
     ap = (eye(n)-fm)|ones(1,n);
    chsi = sumc((invpd(ap'*ap))');
    chsi = maxc(chsi'|zeros(1,n));  @ This line eliminates roundoff error @
     if kc > 1;
         "";"Matrix of Markov transition probabilities:";pm;
         "";"Ergodic probs for full state vector:";chsi';
         "";"Ergodic probs for primitive states:";
                  pq = hp*chsi;pq[1:ns,1]';
     endif;

@ Filter iteration @
   f = 0;
   it = 1;
   do until it > captst;
     fx = chsi .* eta[it,.]';
     fit = sumc(fx);
     skif[it,.] = fx'/fit;
     f = f + ln(fit);
     chsi = fm*fx/fit;
   it = it+1;
   endo;

@ Make Bayesian adjustment to likelihood if desired @
if a > 0;
    fj = 0;
    ij = 1;
    do until ij > ns;
       fj = fj + a*ln(sig[ij,1]) + b/sig[ij,1]
             + c*(mu[ij,1]^2/sig[ij,1]);
    ij = ij +1;
    endo;
    f = f - fj/2;
endif;

@ Calculate smoothed probs if desired @
if ks == 2;
   skis[captst,.] = skif[captst,.];
   it = 1;
   do until it == captst;
      if minc(skif[captst-it,.]') > 1.e-150;
         skis[captst-it,.] = skif[captst-it,.].*
               ((skis[captst-it+1,.]./(skif[captst-it,.]*fm'))*fm);
      else;   @ adjust code so as not to divide by zero @
          hk = skif[captst-it,.]*fm';
          ihk = 1;
          do until ihk > n;
              if hk[1,ihk] > 1.e-150;
                 hk[1,ihk] = skis[captst-it+1,ihk]/hk[1,ihk];
              else;
                 hk[1,ihk] = 0;
              endif;
          ihk = ihk + 1;
          endo;
          skis[captst-it,.] = skif[captst-it,.].*(hk*fm);
      endif;
   it = it+1;
   endo;
endif;

@ Print out value of log likelihood if desired @
if kc == 2;
    "";"Log likelihood:";f;

 endif;

retp(-f);
endp;
/*=========================================================================*/
